#include "testlib.h"
#include <bits/stdc++.h>
#include <algorithm>
#include <iostream>
typedef std::vector<std::pair<bool, int> > vector_pairs;

void ReadVector(vector_pairs& vec) {
    for (size_t i = 0; i < vec.size(); ++i) {
        inf.skipBlanks();
        if (inf.curChar() == '?') {
            inf.nextChar();
            vec[i] = {0, 0};
        } else {
            vec[i] = {1, inf.readInt()};
        }
    }
}

void ReadVector (std::vector<int> &vec) {
    for (size_t i = 0; i < vec.size(); ++i) {
        inf.skipBlanks();
        vec[i] = inf.readInt();
    }
}

void ReadVector_P(std::vector<int>& vec) {
    for (size_t i = 0; i < vec.size(); ++i) {
        if (ouf.seekEoln() || ouf.seekEof()) {
			
			quitf(_wa, "too few elements\n");
			
            //quitp(0.0, "too few elements\n");
        }
        vec[i] = ouf.readInt();
    }
}

bool is_sorted(std::vector <int>::iterator start, std::vector <int>::iterator finish) {
	bool flag = true;
	std::vector <int>::iterator now, prev;
	now = start;
	prev = start;
	now++;
	while (now != finish) {
		if (*now < *prev)
			flag = false;
		now++;
		prev++;
	}
	return flag;
}


int main(int argc, char * argv []) {
    registerTestlibCmd(argc, argv);

    int n = inf.readInt();
    
    vector_pairs a(n), b(n);
    std::vector<int> merged(2 * n);
    ReadVector(a);
    ReadVector(b);
    ReadVector(merged);

    std::vector<int> a_p(n), b_p(n);
    ReadVector_P(a_p);
    if (!ouf.seekEoln()) {
        quitf(_wa, "too much elements in first sequence\n");
    }

    ReadVector_P(b_p);
    if (!ouf.seekEof()) {
		
		quitf(_wa, "too much elements in second sequence\n");
//      quitp(0.0, "too much elements in second sequence\n");
    }
    
    if (!is_sorted(a_p.begin(), a_p.end())) {
		
		quitf(_wa, "first sequence is not sorted\n");
//        quitp(0.0, "first sequence is not sorted\n");
    }

    if (!is_sorted(b_p.begin(), b_p.end())) {
		
		quitf(_wa, "second sequence is not sorted\n");
//        quitp(0.0, "second sequence is not sorted\n");
    }

    std::vector<int> merged_p(2 * n);
    std::merge(a_p.begin(), a_p.end(), b_p.begin(), b_p.end(), merged_p.begin());
    if (merged != merged_p) {
		
		quitf(_wa, "merge of two sequences is wrong");
//        quitp(0.0, "merge of two sequences is wrong");
    }
    for (int i = 0; i < n; ++i) {
        if (a[i].first && a_p[i] != a[i].second) {
			
			quitf(_wa, "fixed element changed\n");
//            quitp(0.0, "fixed element changed\n");
        }
    }
    for (int i = 0; i < n; ++i) {
        if (b[i].first && b_p[i] != b[i].second) {
			
			quitf(_wa, "fixed element changed\n");
//            quitp(0.0, "fixed element changed\n");
        }
    }
    quitp(70.0, "ok\n");
}

