#include "testlib.h"

#include <bits/stdc++.h>

int costs[55];

int get_number_camp(int i) {
  if (i <= 35) {
    return i / 4;
  }

  i -= 35;
  return 9 - (i + 1) / 2;
}

std::vector<std::pair<int, int> > read_wagons(size_t P, size_t D) {
    std::vector<std::pair<int, int> > res(D);
    for (int i = 0; i < D; i++) {
        int A, B;
        A = inf.readInt();
        B = inf.readInt();

        A--;
        B--;
        res[i] = {A, B};
    }

    return res;
}

void check_free_places(const std::vector<std::pair<int, int> >& wagons, std::vector<std::pair<int, int> >& places) {
    std::set<std::pair<int, int> > s(wagons.begin(), wagons.end());

    for (std::vector<std::pair<int, int> >::iterator it = places.begin(); it != places.end(); it++) {
        if (s.find(*it) == s.end()) {
            quitp(0., "%d wagon, %d place - is already bought", it->first, it->second);
        }
    }
}

void check_count_wagons(size_t K, std::vector<std::pair<int, int> >& places) {
    std::set<std::pair<int, int> > set_places(places.begin(), places.end());
    if (set_places.size() != places.size()) {
        quitp(0., "number of unique tickets isn't equal to number of places");
    }

    std::set<int> set_wagons;
    for (std::vector<std::pair<int, int> >::iterator it = places.begin(); it != places.end(); it++) {
        set_wagons.insert(it->first);
    }

    if (set_wagons.size() > K) {
        quitp(0., "number of wagons are greater than chiefs\n");
    }
}

int get_value_placement(std::vector<std::pair<int, int> >& vec) {
    int val = 0;

    int count[16][10] = {};
    for (std::vector<std::pair<int, int> >::iterator it = vec.begin(); it != vec.end(); it++) {
        val += costs[it->second];
        count[it->first][get_number_camp(it->second)]++;
    }

    for (int i = 0; i < 16; i++)
        for (int j = 0; j < 10; j++)
            val += count[i][j] * (count[i][j] - 1);

    return val;
}

int main(int argc, char* argv[]) {

    for (int i = 0; i <= 34; i += 2)
        costs[i] = 4;
    for (int i = 1; i <= 35; i += 2)
        costs[i] = 3;
    for (int i = 36; i <= 52; i += 2)
        costs[i] = 2;
    for (int i = 37; i <= 53; i += 2)
        costs[i] = 1;

    registerTestlibCmd(argc, argv);

    int P, N, K, D;

    P = inf.readInt();
    N = inf.readInt();
    K = inf.readInt();
    D = inf.readInt();

    std::vector<std::pair<int, int> > wagons = read_wagons(P, D);

    int correct_answer = ans.readInt();
        //part_answer = ouf.readInt();

   // if (ouf.seekEoln() != true) {
   //     quitp(0., "first line should consist exactly 1 integer\n");
   // }



    std::vector<std::pair<int, int> > places_p;
    for (int i = 0; i < N; i++) {
        int A, B;
        A = ouf.readInt();
        B = ouf.readInt();

        if (!(A >= 1 && A <= P) || !(B >= 1 && B <= 54)) {
            quitp(0., "incorrect place: %d wagons, %d place\n", A, B);
        }

        A--;
        B--;

        places_p.push_back({A, B});

        if (!ouf.seekEoln()) {
            quitp(0., "line must consist exactly two numbers\n");
        }
    }

    if (!ouf.seekEof()) {
        quitp(0., "output should consist N + 1 lines\n");
    }

    check_free_places(wagons, places_p);
    check_count_wagons(K, places_p);
    int part_answer = get_value_placement(places_p);

    int score = 70;
	if (part_answer > correct_answer) {
        quitp(80.0, "WOW!\n");
	}
    else if (part_answer >= correct_answer) {
        quitp((double) score, "Full solution\n");
    } else {
        quitp((double)floor(score * ((part_answer + .0) / correct_answer) + 0.5), "Partially solution\n");
    }

}
