#include <cstdio>
#include <vector>
#include "testlib.h"
using namespace std;

int vx[] = {1, 0, -1, 0}, vy[] = {0, 1, 0, -1};

void DFS(vector<string>& F, vector<vector<char> >& used, int y, int x)
{
    used[y][x] = true;
    for (int v = 0; v < 4; v++)
    {
        int ty = y + vy[v], tx = x + vx[v];
        if (ty < 0 || tx < 0 || ty >= F.size() || tx >= F[0].size())
            continue;
        if (used[ty][tx])
            continue;
        if (F[ty][tx] == '.')
            continue;
        DFS(F, used, ty, tx);
    }
}

int main(int argc, char* argv[])
{
    registerTestlibCmd(argc, argv);
    int n = inf.readInt(1, 8);
    int h = ouf.readInt(1, 500, "h");
    int w = ouf.readInt(1, 500, "w");
    vector<vector<string> > A(n);
    for (int i = 0; i < n; i++)
    {
		ouf.readToken();
        for (int y = 0; y < h; y++)
        {
            A[i].push_back(ouf.readToken());
            quitif(A[i].back().size() != w, _wa, "length of line %d of rectangle %d is equal to %d, not %d", y, i, (int)A[i].back().size(), w);
            for (int j = 0; j < w; j++)
				if (A[i].back()[j] != '.' && A[i].back()[j] != '*')
					quitf(_wa, "wrong character");
        }
        vector<vector<char> > used(h, vector<char>(w, 0));
        int comp = 0;
        for (int y = 0; y < h; y++)
            for (int x = 0; x < w; x++)
                if (A[i][y][x] == '*' && !used[y][x])
                    comp++, DFS(A[i], used, y, x);
		if (comp != 1)
			quitf(_wa, "figure %d has %d connected components, not 1", i, comp);
    }

    vector<char> was(1 << n, 0);
    for (int y = 0; y < h; y++)
        for (int x = 0; x < w; x++)
        {
            int msk = 0;
            for (int i = 0; i < n; i++)
                msk |= ((int)(A[i][y][x] == '*')) << i;
            was[msk] = true;
        }
    for (int i = 0; i < was.size(); i++)
    {
        if (!was[i])
        {
            string s;
            for (int j = 0; j < n; j++)
                s.push_back('0' + ((i >> j) & 1));
            quitf(_wa, "bad luck");
        }
    }
    quitp(30.0, "ok, looks fine");
}
